package com.example.autocamerademo;

import java.io.IOException;
import java.util.List;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.hardware.Camera;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;


class Preview extends SurfaceView implements SurfaceHolder.Callback {
	private static final String TAG = "Preview";

    SurfaceHolder mHolder;
    public Camera camera;
    
    Preview(Context context) {
        super(context);
        
        /**Install a SurfaceHolder.Callback so we get notified when the
         * underlying surface is created and destroyed.
         */
        mHolder = getHolder();
        mHolder.addCallback(this);
    }

    public void surfaceCreated(SurfaceHolder holder) {
        /** The Surface has been created, acquire the camera and tell it where to draw. **/
        camera = Camera.open();
        
        try {
			camera.setPreviewDisplay(holder);
			
			/** Take preview photo here... but not work properly... **/
			/**
			camera.setPreviewCallback(new PreviewCallback() {

				public void onPreviewFrame(byte[] data, Camera arg1) {
					FileOutputStream outStream = null;
					try {
						outStream = new FileOutputStream(String.format("/storage/sdcard0/Download/%s.jpg", "previewPhoto"));
						outStream.write(data);
						outStream.close();
						
						Log.w(TAG, "onPreviewFrame - wrote bytes: " + data.length);
						
					} catch (FileNotFoundException e1) {
						e1.printStackTrace();
					} catch (IOException e2) {
						e2.printStackTrace();
					} 
					
					Preview.this.invalidate();
				}
			}); **/
			
		} catch (IOException e) {
			e.printStackTrace();
		} 
    }

    public void surfaceDestroyed(SurfaceHolder holder) {
        /** Surface will be destroyed when we return, so stop the preview. 
         * 	Because the CameraDevice object is not a shared resource, 
         * 	it's very important to release it when the activity is paused.
         */
        camera.stopPreview();
        camera = null;
    }

    public void surfaceChanged(SurfaceHolder holder, int format, int w, int h) {
        /** Now that the size is known, set up the camera parameters and begin
         * the preview.
         */
    	Camera.Parameters parameters = camera.getParameters();
        List<Camera.Size> previewSizes = parameters.getSupportedPreviewSizes();

        /** Use default preview size(if your device support a lot sizes,
         * 	you can choose better one.
         */
        Camera.Size previewSize = previewSizes.get(0);

        parameters.setPreviewSize(previewSize.width, previewSize.height);
        camera.setParameters(parameters);
        camera.startPreview();
    }

    @Override
    public void draw(Canvas canvas) {
    		super.draw(canvas);
    		Paint p= new Paint(Color.RED);
    		Log.d(TAG,"draw");
    		canvas.drawText("PREVIEW", canvas.getWidth() / 2, canvas.getHeight() / 2, p);
    }
}